﻿using System;
using System.Windows;
using System.Windows.Controls;
using CompanySLApp.CompanyServiceReference;

namespace CompanySLApp
{
    public partial class EditCompany : UserControl
    {
        CompanyServiceReference.Companies _company;
        private static int _newPerson = int.MinValue;
        private EditCompany()
        {
            InitializeComponent();
        }

        public EditCompany(CompanyServiceReference.Companies company)
        {
            InitializeComponent();
            _company = company;
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            this.LayoutRoot.DataContext = _company;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Page.ShowLoadingLabel();
            CompanyServiceReference.CompanyServiceClient client = new CompanyServiceReference.CompanyServiceClient();
            client.UpdateCompleted += new EventHandler<CompanySLApp.CompanyServiceReference.UpdateCompletedEventArgs>(client_UpdateCompleted);
            client.UpdateAsync(_company);
        }

        void client_UpdateCompleted(object sender, CompanySLApp.CompanyServiceReference.UpdateCompletedEventArgs e)
        {
            Page.HideLoadingLabel();
            if (e.Error == null)
            {
                this.LayoutRoot.DataContext = null;
                _company = e.Result;
                this.LayoutRoot.DataContext = _company;
                MessageBox.Show("Update done", "Company", MessageBoxButton.OK);
            }
            else
            {
                MessageBox.Show("Update failed " + e.Error.ToString(), "Error", MessageBoxButton.OK);
            }
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Page.ShowGrid();
        }

        private void AddPerson_Click(object sender, RoutedEventArgs e)
        {
            var newPerson = new CompanyServiceReference.Persons();
            newPerson.PersonId = _newPerson;
            _newPerson += 1;
            _company.Persons.Add(newPerson);
        }

        private void DeletePerson_Click(object sender, RoutedEventArgs e)
        {
            _company.Persons.Remove(((Button)sender).Tag as Persons);
        }
    }
}
